import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;

public class Hodge extends Applet implements ActionListener
{

	public static int WIDTH=100,HEIGHT=100, RESOLUTION=5;
	private static int N = 100, K1 = 2, K2 = 3, G = 40;

	Timer t;
	boolean paused;
	Button startButton, resetButton;
	TextField width, height, nField, k1Field, k2Field, gField;
	int[][] cells;

    public void init()
    {
		setSize(WIDTH*RESOLUTION+1, HEIGHT*RESOLUTION + 25);
		setLayout(new BorderLayout());
		JPanel buttonPane = new JPanel();
		buttonPane.setLayout(new GridLayout(1,2));
		add("South", buttonPane);

		startButton = new Button("Start");
		startButton.addActionListener(this);
		buttonPane.add(startButton);

		nField = new TextField("100", 3);
		nField.addActionListener(this);
		buttonPane.add(nField);
		k1Field = new TextField("2", 1);
		k1Field.addActionListener(this);
		buttonPane.add(k1Field);
		k2Field = new TextField("3", 1);
		k2Field.addActionListener(this);
		buttonPane.add(k2Field);
		gField = new TextField("40", 2);
		gField.addActionListener(this);
		buttonPane.add(gField);

		resetButton = new Button("Reset");
		resetButton.addActionListener(this);
		buttonPane.add(resetButton);
		width = new TextField("100", 2);
		width.addActionListener(this);
		buttonPane.add(width);
		height = new TextField("100", 2);
		height.addActionListener(this);
		buttonPane.add(height);

    }

    public void start()
    {
		paused = true;
		reset();
		t = new Timer(200, new ActionListener() {
			public void actionPerformed(ActionEvent e){
				tick();
		}});
		t.start();
    }

    public void dosize()
    {
		try
		{
			WIDTH = Integer.parseInt(width.getText());
		}
		catch (NumberFormatException e)
		{
			WIDTH = 100;
		}
		if (WIDTH<1) WIDTH=1;
		if (WIDTH>100) WIDTH=100;
		try
		{
			HEIGHT = Integer.parseInt(height.getText());
		}
		catch (NumberFormatException e)
		{
			HEIGHT = 100;
		}
		if (HEIGHT<1) HEIGHT=1;
		if (HEIGHT>100) HEIGHT=100;
		resize(Math.max(WIDTH*RESOLUTION+1, 251), HEIGHT*RESOLUTION + 25);

		try
		{
			N = Integer.parseInt(nField.getText());
		}
		catch (NumberFormatException ex)
		{
			N = 100;
		}
		if (N<1) N=1;
		try
		{
			K1 = Integer.parseInt(k1Field.getText());
		}
		catch (NumberFormatException ex)
		{
			K1 = 2;
		}
		if (K1<1) K1=1;
		try
		{
			K2 = Integer.parseInt(k2Field.getText());
		}
		catch (NumberFormatException ex)
		{
			K2 = 3;
		}
		if (K2<1) K2=1;
		try
		{
			G = Integer.parseInt(gField.getText());
		}
		catch (NumberFormatException ex)
		{
			G = 40;
		}
		if (G<1) G=1;
		}

	public void reset()
	{
		dosize();

		cells=new int[WIDTH][HEIGHT];
		for(int i=0; i<cells.length;i++)
			for(int j=0; j<cells[0].length;j++)
				cells[i][j]=(int)(Math.random()*(N+1));
		repaint();
	}

    public void destroy()
    {
		//
    }

    public void stop() {
		//
    }

    public String getAppletInfo()
    {
        return "The Hodgepodge Machine";
    }

	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == startButton)
		{
			if (paused)
			{
				paused = false;
				startButton.setLabel("Pause");
			} else {
				paused = true;
				startButton.setLabel("Start");
			}
		}
		else if (e.getSource() == resetButton)
		{
			reset();
			paused = true;
			startButton.setLabel("Start");
		}
	}

	public void paint(Graphics go) {
		Image im=new BufferedImage(WIDTH*RESOLUTION+2,HEIGHT*RESOLUTION+2,BufferedImage.TYPE_INT_RGB);
		Graphics g=im.getGraphics();
		g.setColor(Color.BLACK);
		g.fillRect(0,0,WIDTH*RESOLUTION+2,HEIGHT*RESOLUTION+2);
		for (int i=0;i<cells.length;i++)
		{
			for (int j=0;j<cells[0].length;j++)
			{
				int jr=j*RESOLUTION+1, ir=i*RESOLUTION+1;
				if (cells[i][j]==0)
					g.setColor(Color.BLACK);
				else if (cells[i][j]==N)
					g.setColor(Color.RED);
				else
					g.setColor(new Color(0,(int)(cells[i][j]*200.0/N)+55,0));
				g.fillRect(ir,jr,RESOLUTION,RESOLUTION);
			}
		}
		go.drawImage(im,0,0,null);
	}
	public void update(Graphics go) {
		paint(go);
	}

	public void tick()
	{
		if (paused)
			return;
		int[][] newcells=new int[WIDTH][HEIGHT];
		for (int i=0; i<WIDTH; ++i)
			for (int j=0; j<HEIGHT; ++j)
			{
				int[] nbd = new int[8];
				nbd[0] = (i>0)        ? (cells[i-1][j]) : cells[WIDTH-1][j];
				nbd[1] = (j>0)        ? (cells[i][j-1]) : cells[i][HEIGHT-1];
				nbd[2] = (i<WIDTH-1)  ? (cells[i+1][j]) : cells[0][j];
				nbd[3] = (j<HEIGHT-1) ? (cells[i][j+1]) : cells[i][0];
				nbd[4] = (i>0) ? (j>0) ? (cells[i-1][j-1]) : cells[i-1][HEIGHT-1] : (j>0) ? cells[WIDTH-1][j-1] : cells[WIDTH-1][HEIGHT-1];
				nbd[5] = (i<WIDTH-1) ? (j>0) ? (cells[i+1][j-1]) : cells[i+1][HEIGHT-1] : (j>0) ? cells[0][j-1] : cells[0][HEIGHT-1];
				nbd[6] = (i<WIDTH-1) ? (j<HEIGHT-1) ? (cells[i+1][j+1]) : cells[i+1][0] : (j<HEIGHT-1) ? cells[0][j+1] : cells[0][0];
				nbd[7] = (i>0) ? (j<HEIGHT-1) ? (cells[i-1][j+1]) : cells[i-1][0] : (j<HEIGHT-1) ? cells[WIDTH-1][j+1] : cells[WIDTH-1][0];
				if (cells[i][j]==0)
					{
						double sum=0.0;
						for (int k=0; k<nbd.length; ++k)
						{
							if (nbd[k] == N) sum+=1.0/K2;
							else if (nbd[k] > 0) sum+=1.0/K1;
						}
						newcells[i][j] = (int)sum;
					} else if (cells[i][j] == N) {
						newcells[i][j]=0;
					} else {
						newcells[i][j] = G;
						double sum=cells[i][j];
						double num=1;
						for (int k=0; k<nbd.length; ++k)
						{
							if (nbd[k] < N && nbd[k] > 0) { sum+=nbd[k]; num++; }
						}
						newcells[i][j]+=sum/num;
						if (newcells[i][j]>N) newcells[i][j] = N;
					}
			}
		cells=newcells;
		repaint();
	}

	public void perturb()
	{
		int x = (int)(Math.random()*WIDTH), y = (int)(Math.random()*HEIGHT);
		if (cells[x][y]>0) cells[x][y] = 0;
		else cells[x][y]=1;
		repaint();
	}

}
